//---------------------------------------------------------------------------
#ifndef BVetor2DH
#define BVetor2DH
//---------------------------------------------------------------------------
#include "BPonto2D.h"
//---------------------------------------------------------------------------
class BVetor2D
{
private:
    double x;
    double y;

protected:

public:
    BVetor2D(void);
    BVetor2D(double xx, double yy);
    BVetor2D(const BVetor2D& v);
    virtual ~BVetor2D(void);
    //operadores membro
    BVetor2D& operator = (const BVetor2D& v);
    bool operator == (const BVetor2D& v);
    bool operator != (const BVetor2D& v);
    BVetor2D& operator += (const BVetor2D& v);
    BVetor2D& operator += (double d);
    BVetor2D& operator -= (const BVetor2D& v);
    BVetor2D& operator -= (double d);
    BVetor2D& operator *= (double d);
    BVetor2D& operator /= (double d);
    //operadores nao-membro
    friend BVetor2D operator + (const BVetor2D& v1, const BVetor2D& v2);
    friend BVetor2D operator + (double d, const BVetor2D& v);
    friend BVetor2D operator + (const BVetor2D& v, double d);
    friend BPonto2D operator + (const BPonto2D& p, const BVetor2D& v);
    friend BVetor2D operator - (const BPonto2D& p1, const BPonto2D& p2);
    friend BVetor2D operator - (const BVetor2D& v1, const BVetor2D& v2);
    friend BVetor2D operator - (const BVetor2D& v, double d);
    friend double   operator * (const BVetor2D& v1, const BVetor2D& v2);
    friend BVetor2D operator * (double d, const BVetor2D& p);
    friend BVetor2D operator * (const BVetor2D& v, double d);
    friend BVetor2D operator / (const BVetor2D& v, double d);
    //funcoes membro
    void DefCoordenadas(double xx, double yy);
    inline double& X(void);
    inline const double& X(void) const;
    inline double& Y(void);
    inline const double& Y(void) const;
    //funcoes nao-membro
    friend double abs(const BVetor2D& v);
    friend BVetor2D ProdutoVetorial(const BVetor2D& v1, const BVetor2D& v2);
    friend BVetor2D Unitario(const BVetor2D& v);
};
//---------------------------------------------------------------------------
double& BVetor2D::X(void)
{
    return x;
}
//---------------------------------------------------------------------------
const double& BVetor2D::X(void) const
{
    return x;
}
//---------------------------------------------------------------------------
double& BVetor2D::Y(void)
{
    return y;
}
//---------------------------------------------------------------------------
const double& BVetor2D::Y(void) const
{
    return y;
}
//---------------------------------------------------------------------------
#endif
